#ifndef FULLDUPLEX_SERIAL_PLUS
#define FULLDUPLEX_SERIAL_PLUS


// Start of firmware blob for FullDuplexSerialPlus
extern int _binary_FullDuplexSerialPlus_dat_start;

class FullDuplexSerialPlus
{
    public:
	FullDuplexSerialPlus();
        int start(int rxpin, int txpin, int mode, int baudrate);
        void stop();
        void tx(int txbyte);
        int rx();
        void rxflush();
        int rxcheck();
        int rxtime(int ms);

    private:
        int   cog;               // cog flag/id

        int   rx_head;           // 9 contiguous LONGS MUST be followed by tx/rx buffers
        int   rx_tail;
        int   tx_head;
        int   tx_tail;
        int   rx_pin;
        int   tx_pin;
        int   rxtx_mode;
        int   bit_ticks;
        char  rx_buffer[16];     // Transmit and receive buffers.
        char  tx_buffer[16];

	int   instance;
	static int count;
};
#endif
